/**
 */
package edu.toronto.cs.se.modelepedia.tso.impl;

import edu.toronto.cs.se.modelepedia.tso.Barrier;
import edu.toronto.cs.se.modelepedia.tso.Commit;
import edu.toronto.cs.se.modelepedia.tso.Function;
import edu.toronto.cs.se.modelepedia.tso.Read;
import edu.toronto.cs.se.modelepedia.tso.Synch;
import edu.toronto.cs.se.modelepedia.tso.TSOPackage;
import edu.toronto.cs.se.modelepedia.tso.TSOReadWriteSynch;
import edu.toronto.cs.se.modelepedia.tso.Transition;
import edu.toronto.cs.se.modelepedia.tso.Write;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.impl.EObjectImpl;

import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.InternalEList;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Read Write Synch</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link edu.toronto.cs.se.modelepedia.tso.impl.TSOReadWriteSynchImpl#getName <em>Name</em>}</li>
 *   <li>{@link edu.toronto.cs.se.modelepedia.tso.impl.TSOReadWriteSynchImpl#getReads <em>Reads</em>}</li>
 *   <li>{@link edu.toronto.cs.se.modelepedia.tso.impl.TSOReadWriteSynchImpl#getWrites <em>Writes</em>}</li>
 *   <li>{@link edu.toronto.cs.se.modelepedia.tso.impl.TSOReadWriteSynchImpl#getCommits <em>Commits</em>}</li>
 *   <li>{@link edu.toronto.cs.se.modelepedia.tso.impl.TSOReadWriteSynchImpl#getFunctions <em>Functions</em>}</li>
 *   <li>{@link edu.toronto.cs.se.modelepedia.tso.impl.TSOReadWriteSynchImpl#getBarriers <em>Barriers</em>}</li>
 *   <li>{@link edu.toronto.cs.se.modelepedia.tso.impl.TSOReadWriteSynchImpl#getTransitions <em>Transitions</em>}</li>
 *   <li>{@link edu.toronto.cs.se.modelepedia.tso.impl.TSOReadWriteSynchImpl#getSynchronizations <em>Synchronizations</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class TSOReadWriteSynchImpl extends EObjectImpl implements TSOReadWriteSynch {
	/**
	 * The default value of the '{@link #getName() <em>Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getName()
	 * @generated
	 * @ordered
	 */
	protected static final String NAME_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getName() <em>Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getName()
	 * @generated
	 * @ordered
	 */
	protected String name = NAME_EDEFAULT;

	/**
	 * The cached value of the '{@link #getReads() <em>Reads</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getReads()
	 * @generated
	 * @ordered
	 */
	protected EList<Read> reads;

	/**
	 * The cached value of the '{@link #getWrites() <em>Writes</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getWrites()
	 * @generated
	 * @ordered
	 */
	protected EList<Write> writes;

	/**
	 * The cached value of the '{@link #getCommits() <em>Commits</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getCommits()
	 * @generated
	 * @ordered
	 */
	protected EList<Commit> commits;

	/**
	 * The cached value of the '{@link #getFunctions() <em>Functions</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getFunctions()
	 * @generated
	 * @ordered
	 */
	protected EList<Function> functions;

	/**
	 * The cached value of the '{@link #getBarriers() <em>Barriers</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getBarriers()
	 * @generated
	 * @ordered
	 */
	protected EList<Barrier> barriers;

	/**
	 * The cached value of the '{@link #getTransitions() <em>Transitions</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getTransitions()
	 * @generated
	 * @ordered
	 */
	protected EList<Transition> transitions;

	/**
	 * The cached value of the '{@link #getSynchronizations() <em>Synchronizations</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getSynchronizations()
	 * @generated
	 * @ordered
	 */
	protected EList<Synch> synchronizations;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected TSOReadWriteSynchImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return TSOPackage.Literals.TSO_READ_WRITE_SYNCH;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getName() {
		return name;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setName(String newName) {
		String oldName = name;
		name = newName;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, TSOPackage.TSO_READ_WRITE_SYNCH__NAME, oldName, name));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<Read> getReads() {
		if (reads == null) {
			reads = new EObjectContainmentEList<Read>(Read.class, this, TSOPackage.TSO_READ_WRITE_SYNCH__READS);
		}
		return reads;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<Write> getWrites() {
		if (writes == null) {
			writes = new EObjectContainmentEList<Write>(Write.class, this, TSOPackage.TSO_READ_WRITE_SYNCH__WRITES);
		}
		return writes;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<Commit> getCommits() {
		if (commits == null) {
			commits = new EObjectContainmentEList<Commit>(Commit.class, this, TSOPackage.TSO_READ_WRITE_SYNCH__COMMITS);
		}
		return commits;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<Function> getFunctions() {
		if (functions == null) {
			functions = new EObjectContainmentEList<Function>(Function.class, this, TSOPackage.TSO_READ_WRITE_SYNCH__FUNCTIONS);
		}
		return functions;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<Barrier> getBarriers() {
		if (barriers == null) {
			barriers = new EObjectContainmentEList<Barrier>(Barrier.class, this, TSOPackage.TSO_READ_WRITE_SYNCH__BARRIERS);
		}
		return barriers;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<Transition> getTransitions() {
		if (transitions == null) {
			transitions = new EObjectContainmentEList<Transition>(Transition.class, this, TSOPackage.TSO_READ_WRITE_SYNCH__TRANSITIONS);
		}
		return transitions;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<Synch> getSynchronizations() {
		if (synchronizations == null) {
			synchronizations = new EObjectContainmentEList<Synch>(Synch.class, this, TSOPackage.TSO_READ_WRITE_SYNCH__SYNCHRONIZATIONS);
		}
		return synchronizations;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case TSOPackage.TSO_READ_WRITE_SYNCH__READS:
				return ((InternalEList<?>)getReads()).basicRemove(otherEnd, msgs);
			case TSOPackage.TSO_READ_WRITE_SYNCH__WRITES:
				return ((InternalEList<?>)getWrites()).basicRemove(otherEnd, msgs);
			case TSOPackage.TSO_READ_WRITE_SYNCH__COMMITS:
				return ((InternalEList<?>)getCommits()).basicRemove(otherEnd, msgs);
			case TSOPackage.TSO_READ_WRITE_SYNCH__FUNCTIONS:
				return ((InternalEList<?>)getFunctions()).basicRemove(otherEnd, msgs);
			case TSOPackage.TSO_READ_WRITE_SYNCH__BARRIERS:
				return ((InternalEList<?>)getBarriers()).basicRemove(otherEnd, msgs);
			case TSOPackage.TSO_READ_WRITE_SYNCH__TRANSITIONS:
				return ((InternalEList<?>)getTransitions()).basicRemove(otherEnd, msgs);
			case TSOPackage.TSO_READ_WRITE_SYNCH__SYNCHRONIZATIONS:
				return ((InternalEList<?>)getSynchronizations()).basicRemove(otherEnd, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case TSOPackage.TSO_READ_WRITE_SYNCH__NAME:
				return getName();
			case TSOPackage.TSO_READ_WRITE_SYNCH__READS:
				return getReads();
			case TSOPackage.TSO_READ_WRITE_SYNCH__WRITES:
				return getWrites();
			case TSOPackage.TSO_READ_WRITE_SYNCH__COMMITS:
				return getCommits();
			case TSOPackage.TSO_READ_WRITE_SYNCH__FUNCTIONS:
				return getFunctions();
			case TSOPackage.TSO_READ_WRITE_SYNCH__BARRIERS:
				return getBarriers();
			case TSOPackage.TSO_READ_WRITE_SYNCH__TRANSITIONS:
				return getTransitions();
			case TSOPackage.TSO_READ_WRITE_SYNCH__SYNCHRONIZATIONS:
				return getSynchronizations();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case TSOPackage.TSO_READ_WRITE_SYNCH__NAME:
				setName((String)newValue);
				return;
			case TSOPackage.TSO_READ_WRITE_SYNCH__READS:
				getReads().clear();
				getReads().addAll((Collection<? extends Read>)newValue);
				return;
			case TSOPackage.TSO_READ_WRITE_SYNCH__WRITES:
				getWrites().clear();
				getWrites().addAll((Collection<? extends Write>)newValue);
				return;
			case TSOPackage.TSO_READ_WRITE_SYNCH__COMMITS:
				getCommits().clear();
				getCommits().addAll((Collection<? extends Commit>)newValue);
				return;
			case TSOPackage.TSO_READ_WRITE_SYNCH__FUNCTIONS:
				getFunctions().clear();
				getFunctions().addAll((Collection<? extends Function>)newValue);
				return;
			case TSOPackage.TSO_READ_WRITE_SYNCH__BARRIERS:
				getBarriers().clear();
				getBarriers().addAll((Collection<? extends Barrier>)newValue);
				return;
			case TSOPackage.TSO_READ_WRITE_SYNCH__TRANSITIONS:
				getTransitions().clear();
				getTransitions().addAll((Collection<? extends Transition>)newValue);
				return;
			case TSOPackage.TSO_READ_WRITE_SYNCH__SYNCHRONIZATIONS:
				getSynchronizations().clear();
				getSynchronizations().addAll((Collection<? extends Synch>)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case TSOPackage.TSO_READ_WRITE_SYNCH__NAME:
				setName(NAME_EDEFAULT);
				return;
			case TSOPackage.TSO_READ_WRITE_SYNCH__READS:
				getReads().clear();
				return;
			case TSOPackage.TSO_READ_WRITE_SYNCH__WRITES:
				getWrites().clear();
				return;
			case TSOPackage.TSO_READ_WRITE_SYNCH__COMMITS:
				getCommits().clear();
				return;
			case TSOPackage.TSO_READ_WRITE_SYNCH__FUNCTIONS:
				getFunctions().clear();
				return;
			case TSOPackage.TSO_READ_WRITE_SYNCH__BARRIERS:
				getBarriers().clear();
				return;
			case TSOPackage.TSO_READ_WRITE_SYNCH__TRANSITIONS:
				getTransitions().clear();
				return;
			case TSOPackage.TSO_READ_WRITE_SYNCH__SYNCHRONIZATIONS:
				getSynchronizations().clear();
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case TSOPackage.TSO_READ_WRITE_SYNCH__NAME:
				return NAME_EDEFAULT == null ? name != null : !NAME_EDEFAULT.equals(name);
			case TSOPackage.TSO_READ_WRITE_SYNCH__READS:
				return reads != null && !reads.isEmpty();
			case TSOPackage.TSO_READ_WRITE_SYNCH__WRITES:
				return writes != null && !writes.isEmpty();
			case TSOPackage.TSO_READ_WRITE_SYNCH__COMMITS:
				return commits != null && !commits.isEmpty();
			case TSOPackage.TSO_READ_WRITE_SYNCH__FUNCTIONS:
				return functions != null && !functions.isEmpty();
			case TSOPackage.TSO_READ_WRITE_SYNCH__BARRIERS:
				return barriers != null && !barriers.isEmpty();
			case TSOPackage.TSO_READ_WRITE_SYNCH__TRANSITIONS:
				return transitions != null && !transitions.isEmpty();
			case TSOPackage.TSO_READ_WRITE_SYNCH__SYNCHRONIZATIONS:
				return synchronizations != null && !synchronizations.isEmpty();
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (name: ");
		result.append(name);
		result.append(')');
		return result.toString();
	}

} //TSOReadWriteSynchImpl
