package edu.toronto.cs.se.modelepedia.tso.diagram.providers;

import org.eclipse.core.runtime.IAdaptable;
import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.gmf.runtime.common.core.service.AbstractProvider;
import org.eclipse.gmf.runtime.common.core.service.IOperation;
import org.eclipse.gmf.runtime.common.ui.services.parser.GetParserOperation;
import org.eclipse.gmf.runtime.common.ui.services.parser.IParser;
import org.eclipse.gmf.runtime.common.ui.services.parser.IParserProvider;
import org.eclipse.gmf.runtime.common.ui.services.parser.ParserService;
import org.eclipse.gmf.runtime.emf.type.core.IElementType;
import org.eclipse.gmf.runtime.emf.ui.services.parser.ParserHintAdapter;
import org.eclipse.gmf.runtime.notation.View;

import edu.toronto.cs.se.modelepedia.tso.TSOPackage;
import edu.toronto.cs.se.modelepedia.tso.diagram.edit.parts.BarrierIdEditPart;
import edu.toronto.cs.se.modelepedia.tso.diagram.edit.parts.BarrierIsStartEditPart;
import edu.toronto.cs.se.modelepedia.tso.diagram.edit.parts.BarrierUidEditPart;
import edu.toronto.cs.se.modelepedia.tso.diagram.edit.parts.CommitIdEditPart;
import edu.toronto.cs.se.modelepedia.tso.diagram.edit.parts.CommitUidEditPart;
import edu.toronto.cs.se.modelepedia.tso.diagram.edit.parts.CommitVariableEditPart;
import edu.toronto.cs.se.modelepedia.tso.diagram.edit.parts.CommitWIdEditPart;
import edu.toronto.cs.se.modelepedia.tso.diagram.edit.parts.FunctionIdEditPart;
import edu.toronto.cs.se.modelepedia.tso.diagram.edit.parts.FunctionIsStartEditPart;
import edu.toronto.cs.se.modelepedia.tso.diagram.edit.parts.FunctionNameEditPart;
import edu.toronto.cs.se.modelepedia.tso.diagram.edit.parts.FunctionUidEditPart;
import edu.toronto.cs.se.modelepedia.tso.diagram.edit.parts.ReadIdEditPart;
import edu.toronto.cs.se.modelepedia.tso.diagram.edit.parts.ReadIsStartEditPart;
import edu.toronto.cs.se.modelepedia.tso.diagram.edit.parts.ReadUidEditPart;
import edu.toronto.cs.se.modelepedia.tso.diagram.edit.parts.ReadVariableEditPart;
import edu.toronto.cs.se.modelepedia.tso.diagram.edit.parts.WriteIdEditPart;
import edu.toronto.cs.se.modelepedia.tso.diagram.edit.parts.WriteIsStartEditPart;
import edu.toronto.cs.se.modelepedia.tso.diagram.edit.parts.WriteUidEditPart;
import edu.toronto.cs.se.modelepedia.tso.diagram.edit.parts.WriteVariableEditPart;
import edu.toronto.cs.se.modelepedia.tso.diagram.parsers.MessageFormatParser;
import edu.toronto.cs.se.modelepedia.tso.diagram.part.TSOVisualIDRegistry;

/**
 * @generated
 */
public class TSOParserProvider extends AbstractProvider implements
		IParserProvider {

	/**
	 * @generated
	 */
	private IParser writeId_5001Parser;

	/**
	 * @generated
	 */
	private IParser getWriteId_5001Parser() {
		if (writeId_5001Parser == null) {
			EAttribute[] features = new EAttribute[] { TSOPackage.eINSTANCE
					.getOperation_Id() };
			EAttribute[] editableFeatures = new EAttribute[] { TSOPackage.eINSTANCE
					.getOperation_Id() };
			MessageFormatParser parser = new MessageFormatParser(features,
					editableFeatures);
			writeId_5001Parser = parser;
		}
		return writeId_5001Parser;
	}

	/**
	 * @generated
	 */
	private IParser writeUid_5002Parser;

	/**
	 * @generated
	 */
	private IParser getWriteUid_5002Parser() {
		if (writeUid_5002Parser == null) {
			EAttribute[] features = new EAttribute[] { TSOPackage.eINSTANCE
					.getOperation_Uid() };
			EAttribute[] editableFeatures = new EAttribute[] { TSOPackage.eINSTANCE
					.getOperation_Uid() };
			MessageFormatParser parser = new MessageFormatParser(features,
					editableFeatures);
			writeUid_5002Parser = parser;
		}
		return writeUid_5002Parser;
	}

	/**
	 * @generated
	 */
	private IParser writeVariable_5003Parser;

	/**
	 * @generated
	 */
	private IParser getWriteVariable_5003Parser() {
		if (writeVariable_5003Parser == null) {
			EAttribute[] features = new EAttribute[] { TSOPackage.eINSTANCE
					.getWrite_Variable() };
			EAttribute[] editableFeatures = new EAttribute[] { TSOPackage.eINSTANCE
					.getWrite_Variable() };
			MessageFormatParser parser = new MessageFormatParser(features,
					editableFeatures);
			writeVariable_5003Parser = parser;
		}
		return writeVariable_5003Parser;
	}

	/**
	 * @generated
	 */
	private IParser writeIsStart_5004Parser;

	/**
	 * @generated
	 */
	private IParser getWriteIsStart_5004Parser() {
		if (writeIsStart_5004Parser == null) {
			EAttribute[] features = new EAttribute[] { TSOPackage.eINSTANCE
					.getOperation_IsStart() };
			EAttribute[] editableFeatures = new EAttribute[] { TSOPackage.eINSTANCE
					.getOperation_IsStart() };
			MessageFormatParser parser = new MessageFormatParser(features,
					editableFeatures);
			writeIsStart_5004Parser = parser;
		}
		return writeIsStart_5004Parser;
	}

	/**
	 * @generated
	 */
	private IParser readId_5005Parser;

	/**
	 * @generated
	 */
	private IParser getReadId_5005Parser() {
		if (readId_5005Parser == null) {
			EAttribute[] features = new EAttribute[] { TSOPackage.eINSTANCE
					.getOperation_Id() };
			EAttribute[] editableFeatures = new EAttribute[] { TSOPackage.eINSTANCE
					.getOperation_Id() };
			MessageFormatParser parser = new MessageFormatParser(features,
					editableFeatures);
			readId_5005Parser = parser;
		}
		return readId_5005Parser;
	}

	/**
	 * @generated
	 */
	private IParser readUid_5006Parser;

	/**
	 * @generated
	 */
	private IParser getReadUid_5006Parser() {
		if (readUid_5006Parser == null) {
			EAttribute[] features = new EAttribute[] { TSOPackage.eINSTANCE
					.getOperation_Uid() };
			EAttribute[] editableFeatures = new EAttribute[] { TSOPackage.eINSTANCE
					.getOperation_Uid() };
			MessageFormatParser parser = new MessageFormatParser(features,
					editableFeatures);
			readUid_5006Parser = parser;
		}
		return readUid_5006Parser;
	}

	/**
	 * @generated
	 */
	private IParser readVariable_5007Parser;

	/**
	 * @generated
	 */
	private IParser getReadVariable_5007Parser() {
		if (readVariable_5007Parser == null) {
			EAttribute[] features = new EAttribute[] { TSOPackage.eINSTANCE
					.getRead_Variable() };
			EAttribute[] editableFeatures = new EAttribute[] { TSOPackage.eINSTANCE
					.getRead_Variable() };
			MessageFormatParser parser = new MessageFormatParser(features,
					editableFeatures);
			readVariable_5007Parser = parser;
		}
		return readVariable_5007Parser;
	}

	/**
	 * @generated
	 */
	private IParser readIsStart_5008Parser;

	/**
	 * @generated
	 */
	private IParser getReadIsStart_5008Parser() {
		if (readIsStart_5008Parser == null) {
			EAttribute[] features = new EAttribute[] { TSOPackage.eINSTANCE
					.getOperation_IsStart() };
			EAttribute[] editableFeatures = new EAttribute[] { TSOPackage.eINSTANCE
					.getOperation_IsStart() };
			MessageFormatParser parser = new MessageFormatParser(features,
					editableFeatures);
			readIsStart_5008Parser = parser;
		}
		return readIsStart_5008Parser;
	}

	/**
	 * @generated
	 */
	private IParser barrierId_5009Parser;

	/**
	 * @generated
	 */
	private IParser getBarrierId_5009Parser() {
		if (barrierId_5009Parser == null) {
			EAttribute[] features = new EAttribute[] { TSOPackage.eINSTANCE
					.getOperation_Id() };
			EAttribute[] editableFeatures = new EAttribute[] { TSOPackage.eINSTANCE
					.getOperation_Id() };
			MessageFormatParser parser = new MessageFormatParser(features,
					editableFeatures);
			barrierId_5009Parser = parser;
		}
		return barrierId_5009Parser;
	}

	/**
	 * @generated
	 */
	private IParser barrierUid_5010Parser;

	/**
	 * @generated
	 */
	private IParser getBarrierUid_5010Parser() {
		if (barrierUid_5010Parser == null) {
			EAttribute[] features = new EAttribute[] { TSOPackage.eINSTANCE
					.getOperation_Uid() };
			EAttribute[] editableFeatures = new EAttribute[] { TSOPackage.eINSTANCE
					.getOperation_Uid() };
			MessageFormatParser parser = new MessageFormatParser(features,
					editableFeatures);
			barrierUid_5010Parser = parser;
		}
		return barrierUid_5010Parser;
	}

	/**
	 * @generated
	 */
	private IParser barrierIsStart_5011Parser;

	/**
	 * @generated
	 */
	private IParser getBarrierIsStart_5011Parser() {
		if (barrierIsStart_5011Parser == null) {
			EAttribute[] features = new EAttribute[] { TSOPackage.eINSTANCE
					.getOperation_IsStart() };
			EAttribute[] editableFeatures = new EAttribute[] { TSOPackage.eINSTANCE
					.getOperation_IsStart() };
			MessageFormatParser parser = new MessageFormatParser(features,
					editableFeatures);
			barrierIsStart_5011Parser = parser;
		}
		return barrierIsStart_5011Parser;
	}

	/**
	 * @generated
	 */
	private IParser functionId_5012Parser;

	/**
	 * @generated
	 */
	private IParser getFunctionId_5012Parser() {
		if (functionId_5012Parser == null) {
			EAttribute[] features = new EAttribute[] { TSOPackage.eINSTANCE
					.getOperation_Id() };
			EAttribute[] editableFeatures = new EAttribute[] { TSOPackage.eINSTANCE
					.getOperation_Id() };
			MessageFormatParser parser = new MessageFormatParser(features,
					editableFeatures);
			functionId_5012Parser = parser;
		}
		return functionId_5012Parser;
	}

	/**
	 * @generated
	 */
	private IParser functionUid_5013Parser;

	/**
	 * @generated
	 */
	private IParser getFunctionUid_5013Parser() {
		if (functionUid_5013Parser == null) {
			EAttribute[] features = new EAttribute[] { TSOPackage.eINSTANCE
					.getOperation_Uid() };
			EAttribute[] editableFeatures = new EAttribute[] { TSOPackage.eINSTANCE
					.getOperation_Uid() };
			MessageFormatParser parser = new MessageFormatParser(features,
					editableFeatures);
			functionUid_5013Parser = parser;
		}
		return functionUid_5013Parser;
	}

	/**
	 * @generated
	 */
	private IParser functionName_5014Parser;

	/**
	 * @generated
	 */
	private IParser getFunctionName_5014Parser() {
		if (functionName_5014Parser == null) {
			EAttribute[] features = new EAttribute[] { TSOPackage.eINSTANCE
					.getFunction_Name() };
			EAttribute[] editableFeatures = new EAttribute[] { TSOPackage.eINSTANCE
					.getFunction_Name() };
			MessageFormatParser parser = new MessageFormatParser(features,
					editableFeatures);
			functionName_5014Parser = parser;
		}
		return functionName_5014Parser;
	}

	/**
	 * @generated
	 */
	private IParser functionIsStart_5015Parser;

	/**
	 * @generated
	 */
	private IParser getFunctionIsStart_5015Parser() {
		if (functionIsStart_5015Parser == null) {
			EAttribute[] features = new EAttribute[] { TSOPackage.eINSTANCE
					.getOperation_IsStart() };
			EAttribute[] editableFeatures = new EAttribute[] { TSOPackage.eINSTANCE
					.getOperation_IsStart() };
			MessageFormatParser parser = new MessageFormatParser(features,
					editableFeatures);
			functionIsStart_5015Parser = parser;
		}
		return functionIsStart_5015Parser;
	}

	/**
	 * @generated
	 */
	private IParser commitId_5016Parser;

	/**
	 * @generated
	 */
	private IParser getCommitId_5016Parser() {
		if (commitId_5016Parser == null) {
			EAttribute[] features = new EAttribute[] { TSOPackage.eINSTANCE
					.getOperation_Id() };
			EAttribute[] editableFeatures = new EAttribute[] { TSOPackage.eINSTANCE
					.getOperation_Id() };
			MessageFormatParser parser = new MessageFormatParser(features,
					editableFeatures);
			commitId_5016Parser = parser;
		}
		return commitId_5016Parser;
	}

	/**
	 * @generated
	 */
	private IParser commitUid_5017Parser;

	/**
	 * @generated
	 */
	private IParser getCommitUid_5017Parser() {
		if (commitUid_5017Parser == null) {
			EAttribute[] features = new EAttribute[] { TSOPackage.eINSTANCE
					.getOperation_Uid() };
			EAttribute[] editableFeatures = new EAttribute[] { TSOPackage.eINSTANCE
					.getOperation_Uid() };
			MessageFormatParser parser = new MessageFormatParser(features,
					editableFeatures);
			commitUid_5017Parser = parser;
		}
		return commitUid_5017Parser;
	}

	/**
	 * @generated
	 */
	private IParser commitVariable_5018Parser;

	/**
	 * @generated
	 */
	private IParser getCommitVariable_5018Parser() {
		if (commitVariable_5018Parser == null) {
			EAttribute[] features = new EAttribute[] { TSOPackage.eINSTANCE
					.getCommit_Variable() };
			EAttribute[] editableFeatures = new EAttribute[] { TSOPackage.eINSTANCE
					.getCommit_Variable() };
			MessageFormatParser parser = new MessageFormatParser(features,
					editableFeatures);
			commitVariable_5018Parser = parser;
		}
		return commitVariable_5018Parser;
	}

	/**
	 * @generated
	 */
	private IParser commitWId_5019Parser;

	/**
	 * @generated
	 */
	private IParser getCommitWId_5019Parser() {
		if (commitWId_5019Parser == null) {
			EAttribute[] features = new EAttribute[] { TSOPackage.eINSTANCE
					.getCommit_WId() };
			EAttribute[] editableFeatures = new EAttribute[] { TSOPackage.eINSTANCE
					.getCommit_WId() };
			MessageFormatParser parser = new MessageFormatParser(features,
					editableFeatures);
			commitWId_5019Parser = parser;
		}
		return commitWId_5019Parser;
	}

	/**
	 * @generated
	 */
	protected IParser getParser(int visualID) {
		switch (visualID) {
		case WriteIdEditPart.VISUAL_ID:
			return getWriteId_5001Parser();
		case WriteUidEditPart.VISUAL_ID:
			return getWriteUid_5002Parser();
		case WriteVariableEditPart.VISUAL_ID:
			return getWriteVariable_5003Parser();
		case WriteIsStartEditPart.VISUAL_ID:
			return getWriteIsStart_5004Parser();
		case ReadIdEditPart.VISUAL_ID:
			return getReadId_5005Parser();
		case ReadUidEditPart.VISUAL_ID:
			return getReadUid_5006Parser();
		case ReadVariableEditPart.VISUAL_ID:
			return getReadVariable_5007Parser();
		case ReadIsStartEditPart.VISUAL_ID:
			return getReadIsStart_5008Parser();
		case BarrierIdEditPart.VISUAL_ID:
			return getBarrierId_5009Parser();
		case BarrierUidEditPart.VISUAL_ID:
			return getBarrierUid_5010Parser();
		case BarrierIsStartEditPart.VISUAL_ID:
			return getBarrierIsStart_5011Parser();
		case FunctionIdEditPart.VISUAL_ID:
			return getFunctionId_5012Parser();
		case FunctionUidEditPart.VISUAL_ID:
			return getFunctionUid_5013Parser();
		case FunctionNameEditPart.VISUAL_ID:
			return getFunctionName_5014Parser();
		case FunctionIsStartEditPart.VISUAL_ID:
			return getFunctionIsStart_5015Parser();
		case CommitIdEditPart.VISUAL_ID:
			return getCommitId_5016Parser();
		case CommitUidEditPart.VISUAL_ID:
			return getCommitUid_5017Parser();
		case CommitVariableEditPart.VISUAL_ID:
			return getCommitVariable_5018Parser();
		case CommitWIdEditPart.VISUAL_ID:
			return getCommitWId_5019Parser();
		}
		return null;
	}

	/**
	 * Utility method that consults ParserService
	 * @generated
	 */
	public static IParser getParser(IElementType type, EObject object,
			String parserHint) {
		return ParserService.getInstance().getParser(
				new HintAdapter(type, object, parserHint));
	}

	/**
	 * @generated
	 */
	public IParser getParser(IAdaptable hint) {
		String vid = (String) hint.getAdapter(String.class);
		if (vid != null) {
			return getParser(TSOVisualIDRegistry.getVisualID(vid));
		}
		View view = (View) hint.getAdapter(View.class);
		if (view != null) {
			return getParser(TSOVisualIDRegistry.getVisualID(view));
		}
		return null;
	}

	/**
	 * @generated
	 */
	public boolean provides(IOperation operation) {
		if (operation instanceof GetParserOperation) {
			IAdaptable hint = ((GetParserOperation) operation).getHint();
			if (TSOElementTypes.getElement(hint) == null) {
				return false;
			}
			return getParser(hint) != null;
		}
		return false;
	}

	/**
	 * @generated
	 */
	private static class HintAdapter extends ParserHintAdapter {

		/**
		 * @generated
		 */
		private final IElementType elementType;

		/**
		 * @generated
		 */
		public HintAdapter(IElementType type, EObject object, String parserHint) {
			super(object, parserHint);
			assert type != null;
			elementType = type;
		}

		/**
		 * @generated
		 */
		public Object getAdapter(Class adapter) {
			if (IElementType.class.equals(adapter)) {
				return elementType;
			}
			return super.getAdapter(adapter);
		}
	}

}
